#lire une image 
from PIL import Image
from PIL import ImageOps
import numpy  # Pour manipuler des tableaux de nombres

im = Image.open('D:/fichierspython/champigris.bmp') 
#data = list(im.getdata())
#print(data)


def OuvrirImgGris(chemin):
    im = Image.open(str(chemin))   #crée un objet im qui contient l'image située à l'adresse indiquée
    largeur,hauteur = im.size   #méthode size récupère les dimensions
    imdata=im.getdata()  #la methode getdata permet de récuperer les valeurs des pixels en liste
    tab=numpy.array(imdata)  #met les données en tableau
    matrix = numpy.reshape(tab,(hauteur,largeur))  #met les données sous forme de matrice
    return matrix

def CreerImgGris(matrix,path): #matrice de l'image à reconstruire, plus chemin de sortie.
    size=(matrix.shape[1],matrix.shape[0]) #entre matrice et image l'ordre des dimensions est inversé
    im2 = Image.new("L",size)
    im2.putdata(list(matrix.flat))
    im2.save(fp=str(path))



matrice1=OuvrirImgGris('D:/fichierspython/champigris.bmp')
print(matrice1)
print(matrice1.shape)

matrice2=numpy.copy(matrice1)

#ecrire un code qui permet de calculer le niveau de gris moyen de l'image


#ecrire un code qui permet d'augmenter le contraste de l'image


#pour aller plus loin: ecrire un code qui permet de symétriser l'image




##et avec de la couleur...


def OuvrirImgCoul(path):
    im = Image.open(str(path))   #crée un objet im qui contient l'image située à l'adresse indiquée
    largeur,hauteur = im.size   #méthode size récupère les dimensions
    imdata=im.getdata()  #la methode getdata permet de récuperer les valeurs des pixels en liste    
    tab=numpy.array(imdata)  #met les données en tableau
    matrix = numpy.reshape(tab,(hauteur,largeur,3))  #met les données sous forme de matrice
    return matrix




#créer une image a partir d'une matrice
def CreerImgCoul(matrix,path): #matrice de l'image à reconstruire, plus chemin de sortie.
    matrix=numpy.uint8(matrix) #conversion obligatoire
    imNew=Image.fromarray(matrix)  
    imNew.save(path)


matrice1=OuvrirImgCoul("D:/fichierspython/mario.jpg")
print (matrice1)
print(matrice1.shape)

def composanterouge(matrix):
    matrice2=numpy.array([[[0,0,0]]*225]*225)
    for i in range(225):
        for j in range(225):           
            matrice2[i][j][0]=matrix[i][j][0]
    return matrice2

   
def composanteverte(matrix):
    matrice2=numpy.array([[[0,0,0]]*225]*225)
    for i in range(225):
        for j in range(225):           
            matrice2[i][j][1]=matrix[i][j][1]
    return matrice2

#a ecrire en vous inspirant de composanterouge et composante verte    
def composantebleu(matrix):
    
    
matrice2=composanterouge(matrice1)
matrice3=composanteverte(matrice1)
matrice4=composantebleu(matrice1)

tabg=numpy.concatenate((matrice1,matrice2),axis=0)
tabd=numpy.concatenate((matrice3,matrice4),axis=0)
tab=numpy.concatenate((tabg,tabd),axis=1)

CreerImgCoul(tab,"D:/fichierspython/mariowarhol.jpg")